(function($) {
	
	gamePrototype = function() {
	};
	
	gamePrototype.prototype.init = function() {
		alert('Not implemented!');
	}

	var games = {};

	var methods = {
			
		register : function(name, object) {
			if (methods.hasOwnProperty(name)) {
				console.warn("Game plugin " + name + " is already registered");
				return false;
			}
			if (typeof (object) != 'object') {
				console.warn("Game plugin " + name + " is not valid object");
				return false;
			}
			games[name] = object;
			games[name].prototype = gamePrototype;
			games[name].prototype.parent = gamePrototype;
		},
		
		get : function(name) {
			if (!games.hasOwnProperty(name)) {
				console.warn("Game plugin " + name + " not exist");
				return false;
			}
			return games[name];
		}
	};

	$.gamesRegistry = function(method) {
		if (methods[method]) {
			return methods[method].apply(this, Array.prototype.slice.call(
					arguments, 1));
		} else if (typeof method === 'object' || !method) {
			return methods.init.apply(this, arguments);
		} else {
			$.error('Method ' + method + ' does not exist on jQuery.gamePrototype');
		}
		return this;
	};
})(jQuery);




/**
 * Klasa która ma za zadanie ujednolicić parsowanie struktur opisujących
 * obszary.
 */

absoluteArea = function(_options) {
	this.options = {
		width : Infinity,
		height : Infinity,
		x : 0,
		y : 0,
		radius : 0,
	};
	$.extend(this.options, _options);
};

absoluteArea.prototype.applyAt = function(htmlObject, _containerOptions) {
	var containerOptions = {
			view_width:Infinity,
			view_height:Infinity,
	}
	$.extend(containerOptions,_containerOptions);

	// Wysokość
	$(htmlObject).width (100 * this.options.width  / containerOptions.view_width  + '%');
	$(htmlObject).height(100 * this.options.height / containerOptions.view_height + '%');
	
	// Pozycja
	if(this.options.x != Infinity) {
		$(htmlObject).css({
			left : 100 * this.options.x / containerOptions.view_width+'%'
		});
	}
	if(this.options.y != Infinity) {
		$(htmlObject).css({
			top  : 100 * this.options.y / containerOptions.view_height+'%'
		});
	}
}




















